//// I2C MEMORY WITH PIC16F84A ////

#define SCL_LINE PORTA.F0
#define SDA_LINE PORTA.F1

unsigned char blocSel_rw;
unsigned char adressByte;
unsigned char dataByteReceive;
unsigned int i;
unsigned short int j;

void startCondition(void);
void stopCondition(void);
void byteSend(unsigned char byte_send);
void ackTest(void);
void ackSend(void);
void noAck(void);
void dataReceive(void);

void main()
{
 TRISA=0x00;
 TRISB=0x00;
 OPTION_REG=0b10000000;
 PORTB=0;
 i=0;
 j=0;
 blocSel_rw=0b10100000;
 adressByte=0b00000000;     // premierre adresse de l'eeprom
 delay_ms(1000);           // attente d'une seconde
 
 //// WRITE EEPROM PER PAGE ROUTINE////    //inutile pour le projet wav player
 /*  while(j!=32)
   {
   startCondition();
   byteSend(blocSel_rw);
   ackTest();
   byteSend(adressByte);
   ackTest();
   for(i=0+j;i<16+j;i++)
   {
   byteSend(dataByteSend[i]);
   ackTest();
   }
   stopCondition();
   delay_ms(20);
   adressByte+=16;
   j+=16;
   }    */

 //////SEQUANCIEL READ EEPROM ROUTINE////

   adressByte=0;
   blocSel_rw.B0=0;
   startCondition();
   byteSend(blocSel_rw);
   ackTest();
   byteSend(adressByte);
   ackTest();
   byteSend(adressByte);  // A SUPPRIMER POUR 24C16
   ackTest();             // A SUPPRIMER POUR 24C16
   blocSel_rw.B0=1;
   startCondition();
   byteSend(blocSel_rw);
   ackTest();
   do
   {
   //dataReceive();       // fonction qui lire l'octet copier ici pour gagner le temps de sauts.
    delay_us(1);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B7=SDA_LINE;
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B6=SDA_LINE;
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B5=SDA_LINE;
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B4=SDA_LINE;
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B3=SDA_LINE;
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B2=SDA_LINE;
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B1=SDA_LINE;
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SCL_LINE=1;
    delay_us(3);
    dataByteReceive.B0=SDA_LINE;
    
   PORTB=dataByteReceive;        //envoie de l'octet recuperer de l'eeprom sur le portb(toute les 125us)
   //delay_ms(1000);             //attente d'une seconde pour lire l'octet envoyer sur le portb afin de verifier la lecture de l'eeprom
   //ackSend();                  // fonction qui envoie l'acquittement copier ici pour gagner le temps de sauts.
    SCL_LINE=0;
    SDA_LINE=1;
    delay_us(3);
    SDA_LINE=0;
    SCL_LINE=1;
    delay_us(3);
    SCL_LINE=0;
    SDA_LINE=1;
    
    i++;
   }
   while(i<2048);                 // boucle jusqu'a dernierre addresse de l'eeprom.
   noAck();
   stopCondition();
}

///////////////////////////////////////////////////////////////////////
//////// FONCTIONS UTILES POUR LIRE ET ECRIRE DANS L'EEPROM ///////////
///////////////////////////////////////////////////////////////////////
void startCondition(void)
{
 SDA_LINE=1;
 SCL_LINE=1;
 delay_us(5);
 SDA_LINE=0;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=1;
}
void stopCondition(void)
{
 SCL_LINE=0;
 SDA_LINE=0;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SDA_LINE=1;
 delay_us(5);
}
void ackTest(void)
{
 SDA_LINE=1;
 SCL_LINE=0;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 //if(SDA_LINE) ERROR;
 SCL_LINE=0;
 SDA_LINE=1;
}
void ackSend(void)
{
 SCL_LINE=0;
 SDA_LINE=1;
 delay_us(4);
 SDA_LINE=0;
 SCL_LINE=1;
 delay_us(4);
 SCL_LINE=0;
 SDA_LINE=1;
 
}
void noAck(void)
{
 SCL_LINE=0;
 SDA_LINE=1;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
}
void byteSend(unsigned char byte_send)
{
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B7;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B6;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B5;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B4;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B3;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B2;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B1;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=byte_send.B0;
 delay_us(5);
 SCL_LINE=1;
 delay_us(5);
 SCL_LINE=0;
 delay_us(5);
 SDA_LINE=1;
 }
 void dataReceive(void)
 {
  //SCL_LINE=0;
  //SDA_LINE=1;
  delay_us(2);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B7=SDA_LINE;
  SCL_LINE=0;
  SDA_LINE=1;
  delay_us(4);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B6=SDA_LINE;
  SCL_LINE=0;
  SDA_LINE=1;
  delay_us(4);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B5=SDA_LINE;
  SCL_LINE=0;
  SDA_LINE=1;
  delay_us(4);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B4=SDA_LINE;
  SCL_LINE=0;
  SDA_LINE=1;
  delay_us(4);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B3=SDA_LINE;
  SCL_LINE=0;
  SDA_LINE=1;
  delay_us(4);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B2=SDA_LINE;
  SCL_LINE=0;
  SDA_LINE=1;
  delay_us(4);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B1=SDA_LINE;
  SCL_LINE=0;
  SDA_LINE=1;
  delay_us(4);
  SCL_LINE=1;
  delay_us(4);
  dataByteReceive.B0=SDA_LINE;
  //SCL_LINE=0;
 }